dnl Copyright (C) 2007-2012  CEA/DEN, EDF R&D, OPEN CASCADE
dnl
dnl Copyright (C) 2003-2007  OPEN CASCADE, EADS/CCR, LIP6, CEA/DEN,
dnl CEDRAT, EDF R&D, LEG, PRINCIPIA R&D, BUREAU VERITAS
dnl
dnl This library is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU Lesser General Public
dnl License as published by the Free Software Foundation; either
dnl version 2.1 of the License.
dnl
dnl This library is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl Lesser General Public License for more details.
dnl
dnl You should have received a copy of the GNU Lesser General Public
dnl License along with this library; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
dnl
dnl See http://www.salome-platform.org/ or email : webmaster.salome@opencascade.com
dnl

AC_DEFUN([CHECK_CPPUNIT],[

AC_CHECKING(for cppunit)

cppunit_ok=yes

dnl were is cppunit ?

AC_ARG_WITH(cppunit,
    [AC_HELP_STRING([--with-cppunit=DIR],[directory path to CPPUNIT installation])],
    [CPPUNITHOME="$withval"
      AC_MSG_RESULT("select $withval as path to CPPUNIT")
    ])

AC_ARG_WITH(cppunit_inc,
    [AC_HELP_STRING([--with-cppunit_inc=DIR],[directory path to CPPUNIT includes])],
    [CPPUNIT_INCLUDES="$withval"
      AC_MSG_RESULT("select $withval as path to CPPUNIT includes")
    ])

if test -z "$CPPUNITHOME"; then
  AC_MSG_RESULT(CPPUNITHOME not defined)
  AC_LANG_PUSH([C++])
  SAVED_LIBS=$LIBS
  LIBS="$LIBS -lcppunit"
  AC_LINK_IFELSE(
   [AC_LANG_PROGRAM([#include <cppunit/TestRunner.h>],
  		  [CppUnit::TestRunner dummy])],
   [cppunit_ok=yes] [CPPUNIT_LIBS="-lcppunit"],
   [cppunit_ok=no])
  LIBS="$SAVED_LIBS"
  AC_LANG_POP()
else
  if test -z "$CPPUNIT_INCLUDES"; then
     CPPUNIT_INCLUDES="$CPPUNITHOME/include"
  fi
fi

if test "x$cppunit_ok" != xyes -a ! -d "$CPPUNITHOME" ; then
  AC_MSG_RESULT(no)
  AC_MSG_WARN(cppunit not found)
  cppunit_ok=no
else
   AC_LANG_SAVE
   AC_LANG_CPLUSPLUS
   CPPFLAGS_old=$CPPFLAGS
   if test -n "$CPPUNIT_INCLUDES"; then
       CPPFLAGS="$CPPFLAGS -I$CPPUNIT_INCLUDES"
   fi
   AC_CHECK_HEADER(cppunit/extensions/HelperMacros.h,cppunit_ok=yes,cppunit_ok=no) 

   CPPFLAGS=$CPPFLAGS_old

   if test "x$cppunit_ok" = xno ; then
     AC_MSG_RESULT(no)
     AC_MSG_WARN(cppunit not found)
   else
     cppunit_ok=yes
   fi

  if  test "x$cppunit_ok" = "xno"
  then
    AC_MSG_RESULT(unable to found cppunit headers and library)
    AC_MSG_RESULT(CPPUNITHOME environment variable may be wrong)
  else
    if test -n "$CPPUNIT_INCLUDES"
    then
      CPPUNIT_INCLUDES="-I$CPPUNIT_INCLUDES"
    fi
    if test -n "$CPPUNITHOME"
    then
      CPPUNIT_LIBS="-L$CPPUNITHOME/lib -lcppunit"
    fi

    AC_SUBST(CPPUNIT_INCLUDES)
    AC_SUBST(CPPUNIT_LIBS)
    AC_SUBST(cppunit_ok)
    AC_MSG_RESULT(yes)
  fi
fi

AM_CONDITIONAL(CPPUNIT_IS_OK, [test x"$cppunit_ok" = xyes])

AC_LANG_RESTORE

])dnl
dnl
